***
***

# <a name="updating"> </a>UPDATING
## <a name="updating-3"> </a>UPDATING FROM 2.x To 3.x
Due to a need to access HTML element to fix mobile glitches, 3.0.2 introduced a
breaking change, mostly the ancestor classes of Ultimenu blocks: body to html,
with some clearer BEM. If you are customizing the styling, please update them
accordingly. Be sure to press `F5` or `CTRL/CMD + R` to clear browser cache, and
also clearing Drupal cache if changing Twig files at
`/admin/config/development/performance`, or `drush cr`.

See CR at https://www.drupal.org/node/3447576.

Before 3.0.2:  
* `body.is-ultimenu-canvas`
* `body.is-ultimenu-canvas--active`
* `body.is-ultimenu-canvas--hover`
* `body.is-ultimenu-canvas--hiding`
* `body.is-ultimenu-expanded`
* `div.is-ultimenu-canvas-backdrop`
* `header.is-ultimenu-canvas-off`
* `header_siblings.is-ultimenu-canvas-on`
* `span.caret`

After 3.0.2  
* `html.is-ultimenu`
* `html.is-ultimenu--active`
* `html.is-ultimenu--hover`
* `html.is-ultimenu--hiding`
* `html.is-ultimenu--expanded`
* `div.is-ultimenu__backdrop`
* `header.is-ultimenu__canvas-off`
* `header_siblings.is-ultimenu__canvas-on`
* `span.ultimenu__caret`

## <a name="updating-2"> </a>UPDATING FROM 1.x To 2.x
If not updating from 1.x to 2.x, please ignore this section.

Ultimenu 2.x is a major rewrite to update for Drupal 8.6+, and add new features.
It may not be compatible with 1.x.
Ultimenu 2.x added few more services, so it may break the site temporarily
mostly due to the introduction of new services. If you do drush, this is no
issue. Running `drush cr`, `drush updb` and `drush cr` should do.

* Have backup routines.
* Test it out at a staging or DEV environment.
* Hit **Clear all caches** at
  [/admin/config/development/performance](/admin/config/development/performance)
  once this updated module is in place after `composer update`. This is
  important so that service or function changes do not interfere the update.
  Keep this page open, never re-load, and keep hitting that cute button if any
  issues.
* Run **/update.php**, or regular `drush cr`, `drush updb` and `drush cr`.

Note the recommended order above!
Read more [here](https://git.drupalcode.org/project/blazy/tree/docs/UPDATING.md?h=8.x-2.x)

The following are changes, in case you are updating from 1.x.


## NOTABLE CHANGES
- The flyouts no longer use `display:none`. Instead `visibility: hidden`. This
  should fix compatibility issues with lazy-loaded images without extra legs.
- Renamed **active-trail** LI class to **is-active-trail** to match core:
  https://www.drupal.org/node/2281785
- Renamed **js-ultimenu-** classes to **is-ultimenu__** so to print it in
  HTML directly not relying on JS, relevant for the new off-canvas menu.
- Added option to selectively enable ajaxified regions.
- Cleaned up CSS sample skins from old browser CSS prefixes. It is 2019.
- Added off-canvas menu to replace old sliding toggle approach.
- Split `ultimenu.css` into `ultimenu.hamburger.css` + `ultimenu.vertical.css`.
- Added support to have a simple iconized title, check out STYLING.


## FYI CHANGES
The following are just FYI, not really affecting the front-end, except likely
temporarily breaking the site till proper `drush cr` mentioned above.

1. UltimenuManager is split into 3 services: UltimenuSkin, UltimenuTool,
   UltimenuTree services for single responsibility, and to reduce complexity.
2. Ultimenu CSS files are moved from module **/skins** folder to **css/theme**.
3. Moved most logic to `#pre_render` to gain some performance.
4. Old `template_preprocess_ultimenu()` loop is also merged into `#pre_render`.
