<?php

namespace Drupal\ultimenu;

/**
 * Provides common Ultimenu utility methods.
 */
class Ultimenu {

  /**
   * Returns available blocks managed by Context.
   *
   * @todo remove beore 3.x.
   */
  public static function contextBlocks($region, array $build): array {
    if ($context_manager = \ultimenu()->service('context.manager')) {
      foreach ($context_manager->getActiveReactions('blocks') as $reaction) {
        $check = $reaction->execute($build);
        return $check[$region] ?? [];
      }
    }
    return [];
  }

  /**
   * Returns available regions disabled by Context.
   *
   * @todo remove beore 3.x.
   */
  public static function contextDisabledRegions($theme): array {
    if ($context_manager = \ultimenu()->service('context.manager')) {
      foreach ($context_manager->getActiveReactions('regions') as $reaction) {
        $check = $reaction->getConfiguration();
        if (isset($check['regions'])
          && $regions = ($check['regions'][$theme] ?? [])) {
          return array_combine($regions, $regions);
        }
      }
    }
    return [];
  }

}
